/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "tile.h"

tilemap_t * tileMapCreate(int32_t columns, int32_t rows) {
  tilemap_t *tilemap = malloc(sizeof(tilemap_t));
  if(tilemap == NULL) return NULL;

  tilemap->tileDefinitions = calloc(columns * rows, sizeof(tiledef_t));
  if(!tilemap->tileDefinitions) {
    free(tilemap);
    return NULL;
  }
  return tilemap;
}

void tileMapDispose(tilemap_t *tilemap) {
  free(tilemap->tileDefinitions);
  free(tilemap);
}

void tileRender(world_t *world, chunk_t *chunk,
  tile_t *tile, tiledef_t *tileDef, int32_t x, int32_t y, int32_t z
) {
  if(tile->id == 1) {
    tilesetdiv_t *div = world->tileset->divisions + tile->id;
    quadBuffer(chunk->primitive, z,
        x,   y, div->x0, div->y0,
      x+1, y+1, div->x1, div->y1,
      tile->verticeStart, tile->indiceStart
    );
  }
}