#pragma once

#include <stdint.h>
#include <malloc.h>
#include "../../engine/display/primitive.h"
#include "../../engine/display/texture.h"
#include "../../engine/display/tileset.h"

typedef uint8_t tileflag_t;
typedef uint8_t tileid_t;

typedef struct {
  tileid_t id;
  void *data;
  int32_t indiceStart, verticeStart;
} tile_t;

typedef struct {
  tileflag_t flags;
  int32_t indiceCount, verticeCount;
} tiledef_t;

typedef struct {
  tiledef_t *tileDefinitions;
} tilemap_t;

typedef struct chunk_t {
  int32_t x, y, z;
  tile_t *tiles;
  primitive_t *primitive;
} chunk_t;

typedef struct {
  char *assetWorldDirectory;

  texture_t *texture;
  tileset_t *tileset;
  tilemap_t *tilemap;

  int32_t x, y, z;
  int32_t count;
  int32_t tileCount;
  chunk_t **chunkList;
  chunk_t *chunks;
} world_t;